// blackrain 1105
Knob {
	var <>knob, <>action, <>color, <>mouseOverAction, <>keyDownFunc, value = 0, <>keystep = 0.01;
	
	*new { arg parent, bounds;
		^super.new.initKnob(parent, bounds)
	}

	initKnob { arg parent, bounds;
		var knobFun;
		color = [Color.blue(0.7, 0.5), Color.green(0.8, 0.8), Color.black.alpha_(0.4)];

		knob = SCUserView.new(parent, bounds)
			.keyDownFunc_({arg me, key, modifiers, unicode;
				keyDownFunc.value(key, modifiers, unicode);
			})
			.mouseOverAction_({arg v, x, y; this.mouseOverAction.value(this, x, y); })
			.mouseDownAction_({arg v, x, y, modifiers;
				knobFun.value(v, x, y, modifiers);
			})
			.mouseTrackFunc_({arg v, x, y, modifiers;
				knobFun.value(v, x, y, modifiers);
			})
			.drawFunc_({
				color[2].set;
		
				Pen.addAnnularWedge(
					knob.bounds.center, 
					knob.bounds.width * 0.5 - 2, 
					knob.bounds.width * 0.5, 	
					0.25pi, 
					-1.5pi
				);
				Pen.perform(\fill);
		
				color[1].set;
				Pen.addAnnularWedge(
					knob.bounds.center, 
					knob.bounds.width * 0.5 - 2, 
					knob.bounds.width * 0.5, 	
					0.75pi, 
					1.5pi * value
				);
				Pen.perform(\fill);
		
				color[0].set;
				Pen.addWedge(knob.bounds.center, knob.bounds.width * 0.5 - 4, 0, 2pi);
				Pen.perform(\fill);
			
				Color.black.alpha_(0.7).set;
				Pen.addWedge(knob.bounds.center, knob.bounds.width * 0.5 - 1, 0.75pi +
					(1.5pi * value), 0.1);
				Pen.perform(\fill);
			});

		knobFun = {arg v, x, y, modifiers;
				var angle;
				angle = (v.bounds.center - Point(x,y)).rotate(0.5pi).theta.clip2(0.75pi);
				value = [-0.75pi, 0.75pi].asSpec.unmap(angle);
				action.value(this, x, y, modifiers);
				v.refresh;
		};

		keyDownFunc = {arg key, modifiers, unicode;
			this.defaultKeyDownAction(key, modifiers, unicode);
		}
	}

	value_ {arg val;
		value = val;
		knob.refresh;
		^value;
	}

	value {
		^value;
	}
	
	valueAction_ {arg val;
		value = val;
		action.value(this);
		knob.refresh;
		^value;
	}
	
	canFocus_ { arg state;
		knob.canFocus_(state);
	}
	// rip from slider
	increment { ^this.valueAction = (this.value + keystep).min(1) }
	decrement { ^this.valueAction = (this.value - keystep).max(0) }

	defaultKeyDownAction { arg char, modifiers, unicode,keycode;
		// standard keydown
		if (char == $r, { this.valueAction = 1.0.rand; });
		if (char == $n, { this.valueAction = 0.0; });
		if (char == $x, { this.valueAction = 1.0; });
		if (char == $c, { this.valueAction = 0.5; });
		if (char == $], { this.increment; ^this });
		if (char == $[, { this.decrement; ^this });
		if (unicode == 16rF700, { this.increment; ^this });
		if (unicode == 16rF703, { this.increment; ^this });
		if (unicode == 16rF701, { this.decrement; ^this });
		if (unicode == 16rF702, { this.decrement; ^this });
	}
	
}

