
ControlPresets {
	var <>controlEnvironment;
	var <>presets;
	var <>interpolationBase;
	var <>interpolationTarget;

	addPreset { 	
		presets = presets.add(controlEnvironment.input); 
	}
	
	removePreset { arg index;
		if (presets.notNil, {
			presets.removeAt(index);
		});
	}

	setPreset { arg index;
		controlEnvironment.input_(presets.at(index));
	}
	
	setGoal { arg index;
		var currentGoal, currentPreset;
		currentGoal = presets.at(index);
		currentPreset = controlEnvironment.input;
		interpolationBase = 2 * currentPreset - currentGoal;
		interpolationTarget = currentGoal - currentPreset 
		
	}

	interpolate { arg index;
		if (interpolationTarget.notNil, {
			controlEnvironment.input_( (index + 1) * interpolationTarget + interpolationBase);
		})
	}	

	load { arg path; var file;
		if (File.exists(path), {
			file = File(path,"r"); 
			presets = file.readAllString.interpret;
			file.close;
		})
	}
	
	save { arg path; 
		File(path,"w").putAll(presets.asCompileString).close;
	}
	
}