Record {
	var <server, <inbus, <numChannels, <headerFormat, <sampleFormat;
	var <isRecording=false, <bufnum, synth;
	*new { |server, inbus=0, numChannels=2, headerFormat='aiff', sampleFormat='int16'|		^super.new.init(server, inbus, numChannels, headerFormat, sampleFormat)
	}
	*initClass { // thanks julian...
		(1 .. 8).do { |i|
			SynthDef.writeOnce("system-diskout-" ++ i.asString, {
				|i_in, i_bufNum=0|
				DiskOut.ar(i_bufNum, In.ar(i_in, i));
			});
		};
	}
	init { |argServer, argInbus, argChans, argHeaderFormat, argSampleFormat|
		server = argServer ? Server.default;
		inbus = argInbus;
		numChannels = argChans;
		headerFormat = argHeaderFormat.asString.collect { |char| char.toLower };
		sampleFormat = argSampleFormat;
		CmdPeriod.add(this);
	}
	start { |path, argBufnum|
		var ext;
		
		if (isRecording) { ^nil };
		ext = headerFormat;
		
		if (ext == "none") { ext = "" } {
			if ( ext == "aiff") { ext = "aif" };
			if ( ext == "sun") { ext = "au" };
			if ( ext == "ircam") { ext = "sf" };
			ext = "." ++ ext;
		};
	
		path = path ? ("recordings/" ++ (Date.localtime.stamp) ++ ext);
		bufnum = argBufnum ? server.bufferAllocator.alloc(1);
	
		server.sendMsg("/b_alloc", bufnum, 32768, numChannels,
			["/b_write", bufnum, path, headerFormat, sampleFormat, 0, 0, 1]
		);
		
		synth = Synth.tail(RootNode(server), "system-diskout-" ++ numChannels,
			[\i_in, inbus, \i_bufNum, bufnum]
		);
	
		isRecording = true;
		this.changed;
		inform("RECORDING...");
	}
	stop {
		if (isRecording.not) { ^nil };
		synth.free;
		server.sendMsg("/b_close", bufnum, ["/b_free", bufnum]);
		isRecording = false;
		this.changed;
		inform("RECORDING STOPPED.");
	}
	cmdPeriod { this.stop }
	inbus_ { |argInbus|
		inbus = argInbus;
		this.changed;
	}	
	numChannels_ { |argNumChannels|
		numChannels = argNumChannels;
		this.changed;
	}
	headerFormat_ { |argHeaderFormat|
		headerFormat = argHeaderFormat.asString.collect { |char| char.toLower };
		this.changed;
	}
	sampleFormat_ { |argSampleFormat|
		sampleFormat = argSampleFormat;
		this.changed;
	}
}