AbstractOpCV : AbstractFunction {
	
	composeUnaryOp { arg aSelector;
		^UnaryOpCV.new(aSelector, this)
	}
	composeBinaryOp { arg aSelector, something;
		^BinaryOpCV.new(aSelector, this, something)
	}
	reverseComposeBinaryOp { arg aSelector, something;
		^BinaryOpCV.new(aSelector, something, this)
	}
	composeNAryOp { arg aSelector, anArgList;
		^{ this.value(anArgList).performList(aSelector, anArgList) }
	}

}

UnaryOpCV : AbstractOpCV {
	var >operator, >a;
	*new { arg operator, a;
		^super.newCopyArgs(operator, a)
	}
	value { arg obj;
		^a.value(obj).perform(operator)
	}

}

BinaryOpCV : AbstractOpCV  {
	var >operator, <>a, <>b;
	*new { arg operator, a, b;	
		^super.newCopyArgs(operator, a, b)
	}
	
	
	value { arg obj;
		var vala, valb;
		vala = a.value(obj);
		valb = b.value(obj);
		^vala.perform(operator, valb)
	}
}


