+ NodeProxy { 
	writeSpecsFile { |path, sep = $\t| 
		var f;
					// no check for existing files here.
		path = (path ?? { this.key ? "proxySpecs" }).asString ++ ".specs";

		f = File(path, "w");
		if (f.isOpen.not) { warn("could not write proxy specs file: " + path); ^this };
		
		this.controlKeysValues.clump(2).do { |keyVal| 
			var key, val, spec;
			var line = "", specValues;
			#key, val = keyVal; 
			key = key.asSymbol;
					
			spec = Spec.specs[key]; 
			if (spec.isNil, { 		// complain if no specs exist:
				warn("// missing spec for param" + key.asCompileString 
					+ ": could not be written! Please add one:");
				("Spec.specs.put(" ++ key.asCompileString ++ ", [0, 1, 'lin', 0.01, 0.5]);").postln;
			}, { 
				specValues = Spec.specs[key].storeArgs;
				specValues.put(5, val); 	// add default from proxy!
				([key] ++ specValues).do { |item|
					line = line ++ item ++ sep;
				};
				f.put(line ++ $\n);
			});
		};
		f.close;
		inform("specs file" + path + "written.");
	} 
	
	writeSettingsFile { |path, except, sep = $\t| 
		var f;
					// no check for existing files here.
		path = (path ?? { this.key ? "proxySpecs" }).asString ++ ".set";

		f = File(path, "w");
		if (f.isOpen.not) { warn("could not write proxy settings file: " + path); ^this };
		
		this.getKeysValues(except: except).do { |pair| 
			var key, val;
			 #key, val = pair; 
			f.put(key.asString ++ sep ++ val ++ $\n);
		};
		f.close;
		inform("settings file" + path + "written.");
	}
}
/***
p = ProxySpace.push; 

~test = { |freq1=234, freq2=567, dens=10| Ringz.ar(Dust.ar(dens), [freq1, freq2], 0.4) };

Spec.specs.put(\freq1, \freq.asSpec);
Spec.specs.put(\freq2, \freq.asSpec);
~test.writeSpecsFile;
TabFileReader.read("test.specs").printcsAll;

Spec.specs.put(\dens, [0, 100, \amp, 0.01, 5].asSpec);
~test.writeSpecsFile;
TabFileReader.read("test.specs").printcsAll;

~test.writeSettingsFile(\test1);
TabFileReader.read("test1.set").printcsAll;
			
			// you can except some params
~test.writeSettingsFile(\test1, [\dens]);
TabFileReader.read("test1.set").printcsAll;
****/