MultiSelect2D {
	classvar <>scheme;
	var <w, compView, <choices, <btns, <>action, <numX, <numY, <selected, <skipjack;
	
	*new { |choices, action, win, comp|
		^super.new.init(choices, action, win, comp);
	}
	*initClass { 
		scheme = ();
		scheme.font =  Font("Monaco", 10);
		scheme.fontColor = Color.black;

		scheme.background = Color.grey(0.9);
		scheme.onColor = Color.white;
		scheme.offColor = Color.grey(0.7);
		
	}
	init { |argChoices, argAction, win, comp|
		var flow; 
		choices = argChoices; 
		action = argAction;
		numX = choices.first.size; 
		numY = choices.size; 

		selected = 0 ! numX ! numY;
	
		w = win ?? { SCWindow(this.class.name, Rect(0, 235, numX * 30 + 10, numY * 16 + 30)) };
		w.view.background_(scheme.background);
		w.front;
		
		compView = comp ?? { SCCompositeView(w, Rect(0, 0, numX * 30 + 10, numY * 16 + 30)); };
		compView.decorator = flow = compView.decorator ?? { FlowLayout(compView.bounds).gap_(0@0) };
		
		btns = choices.collect { |line, i| 
			line.collect { |choice, j| 
				SCButton(w, Rect(j * 30, i * 16,30,16)).font_(scheme.font)
				.states_([
					[choice.asSymbol, scheme.fontColor, scheme.offColor], 
					[choice.asSymbol, scheme.fontColor, scheme.onColor]
				])
				.action_({ |btn| 
					selected[i][j] = btn.value; 
					action.value(this, i, j, selected[i][j]); 
				});
			}
		};
		skipjack = SkipJack({ this.updateBtns }, 0.2, { w.isClosed }, "MultiSel");
	}
			// support multiple selection for i and j
	select { |i, j, val=1| i.asArray.do { |eachi| selected[eachi][j] = val } }
	
	unselect { |i, j| this.select(i, j, 0) }
	
	updateBtns { 
		btns.do { |line, i| line.do { |btn, j| btn.value_(selected[i][j]) } } 
	}

}
