/*
	Filename: EEGMap.sc 
	created: 15.02.2006 

	Copyright (C) IEM 2005 
		Alberto deCampo [decampo@iem.at]
		Christopher Frauenberger [frauenberger@iem.at] 

	This program is free software; you can redistribute it and/or 
	modify it under the terms of the GNU General Public License 
	as published by the Free Software Foundation; either version 2 
	of the License, or (at your option) any later version. 

	This program is distributed in the hope that it will be useful, 
	but WITHOUT ANY WARRANTY; without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
	GNU General Public License for more details. 

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software 
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

	IEM - Institute of Electronic Music and Acoustics, Graz 
	Inffeldgasse 10/3, 8010 Graz, Austria 
	http://iem.at

	SonEnvir project
	http://sonenvir.at
	
	$LastChangedDate$
	$Rev$


	
*/

//	contains some conventional name maps and orders for eeg files in edf format, 
// 	as used in alphatrace software system.

EEGMap { 
	classvar <eegMaps; 
	*initClass { 
		eegMaps = ();

		eegMaps[\bipolarLaengs] = 
		#[	\FP2_F8, 
			\F8_T4, 
			\T4_T6,
			\T6_O2,
			
			\FP1_F7,
			\F7_T3,
			\T3_T5,
			\T5_O1,
			
			\FP2_F4,
			\F4_C4,
			\C4_P4,
			\P4_O2,
			
			\FP1_F3,
			\F3_C3,
			\C3_P3,
			\P3_O1,
			
			\FZ_CZ,
			\CZ_PZ,
			\EKG ];

		eegMaps[\refBasalRing] = #[
			'FP1', 
			'FP2', 
			'F7', 
			'F3', 
			'FZ', 
			'F4', 
			'F8', 

			'T3', 
			'C3', 
			'CZ', 
			'C4', 
			'T4',
			'T5', 
			'P3', 
			'PZ', 
			'P4', 
			'T6', 
			'O1', 
			'O2', 
			'A1', 
			'A2', 

			'EKG',
			'AF7',
			'AF8',
			'F11',
			'F12',
			'FT9',
			'FT10',
			'TP9',
			'TP10' 
		];
		
		eegMaps[\refBasalRing2] = eegMaps[\refBasalRing] ++ ['SPli', 'SPre'];
		
		eegMaps[\absence16] = [ 
			\FP1, \FP2, \F7, \F3,
			\F4, \F8, \T3, \C3, 
			\C4, \T4, \T5, \P3,
			\P4, \T6, \O1, \O2 
		];
		
		eegMaps[\sleepPoly] = [ 
			\FP1, \FP2, \F7, \F3,
			\FZ, \F4, \F8,
			\T3, \C3, \Cz, 
			\C4, \T4, \T5,
			\P3, \Pz, \P4, 
			\T6, \O1, \O2,
			\EOGL, \EOGR,
			\EMG25,
			\EKG, 
			\REF
		];


//		#[	\FP2, \F8, \T4, \T6,		// grouping as shown in viewer
//			\F4, \C4, \P4, \O2,
//			\AF8, \F12, \FT10, \TP10, 
//
//			\FP1, \F7, \T3, \T5,
//			\F3,  \C3,  \P3, \O1,
//			\AF7,  \F11,  \FT9,  \TP9, 
//
//			\FZ, \CZ,  \PZ,  \EKG ];
	} 
	
	*put { |key, map| eegMaps.put(key, map) }
	*new { |name| ^eegMaps[name] } 
	
	*keyForSize { |size|
		var res = eegMaps.select { |list, key| list.size == size }.keys; 
		^res.as(Array).unbubble 	// return single item if just one.
	}
}