/*
	Filename: SEGridData.sc 
	created: 19.02.2006 

	Copyright (C) IEM 2006
		Alberto deCampo [decampo@iem.at]
		Christopher Frauenberger [frauenberger@iem.at] 

	This program is free software; you can redistribute it and/or 
	modify it under the terms of the GNU General Public License 
	as published by the Free Software Foundation; either version 2 
	of the License, or (at your option) any later version. 

	This program is distributed in the hope that it will be useful, 
	but WITHOUT ANY WARRANTY; without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
	GNU General Public License for more details. 

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software 
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

	IEM - Institute of Electronic Music and Acoustics, Graz 
	Inffeldgasse 10/3, 8010 Graz, Austria 
	http://iem.at

	SonEnvir project
	http://sonenvir.at
	
	$LastChangedDate$
	$Rev$
*/

SEGridData { 
	var <>dimensions, <>array, <gridOffsets;
	*new { |dimensions, array| 
		^super.newCopyArgs(dimensions, array).init
		
	}
	init { 
		var stepsize = 1; 
		if (dimensions.product != array.size) { 
			warn("SEGridData: dimensions say size" + dimensions + "=" + dimensions.product + ";
			array size is " + array.size);
		};
		gridOffsets = ([1] 
		++ dimensions.drop(1).reverse.collect { |dim| 
			stepsize = stepsize * dim
		}).reverse;
		
		^this
	}
		// for single values only for now.
	at { |...indices| 
		
		^array[this.rawIndexFor(indices)];
	}
	rawIndexFor { |indices|
		var rawIndex;
		if (indices.size != dimensions.size) { warn("number of dimensions wrong!"); ^-1 };
		if (indices.any(_<0)) { warn("negative indices not supported!"); ^-1 };
		if ((dimensions - indices).any(_<1)) { warn("outside dimensions!"); ^-1 };
		^rawIndex = (indices * gridOffsets).sum;
	}
	prAt { |index| 
		^array[index]
	}
}