+ ArrayedCollection {


scatterplot2D {|window, specX, specY, symbolSize = 1, symbolColor, symbol = \rect, boundingbox = false|
	var adjustedData;

	specX = specX ? [0,1].asSpec;
	specY = specY ? specX;
	symbolColor = symbolColor ? Color.black;
	
	adjustedData = this.collect {|item|
		[specX.unmap(item[0]), specY.unmap(item[1])];
	};
	
	window.drawHook = {|w|
		var width, height, rect, pad = 10;
		
		width =  w.view.bounds.width  - pad;
		height = w.view.bounds.height - pad;
//		[width, height].postln;
		Pen.use{
			symbolColor.set;
			Pen.beginPath;
			if (symbol == \fillRect, {
				adjustedData.do{|item, i|
					rect = Rect(
						(   item[0]  * width)  - (symbolSize/2) + (pad/2),
						((1-item[1]) * height) - (symbolSize/2) + (pad/2), 
						symbolSize, symbolSize
					);
					Pen.fillRect(rect);
				}
			},{
				adjustedData.do{|item, i|
					rect = Rect(
						(   item[0]  * width)  - (symbolSize/2) + (pad/2),
						((1-item[1]) * height) - (symbolSize/2) + (pad/2), 
						symbolSize, symbolSize
					);
					Pen.fillOval(rect);
				}
			});
			if (boundingbox, {
				Pen.strokeRect(Rect(pad/2, pad/2, specX.range*width, specY.range*height))
			});
		}; // end Pen.use
	}; // end window.drawHook
	
	{window.refresh}.defer
}

scatterplot2D_SC {|specX, specY, symbolSize = 1, symbolColor, boundingbox, bounds|
	var window;

	bounds = bounds ? Rect(100, 100, 200, 200);

	window = SCWindow(\plot, bounds);
	window.view.background = Color.white;
	this.scatterplot2D(window, specX, specY, symbolSize, symbolColor);
	^window.front;
}

}
