Pxnrand : ListPattern {
	var <>memSize, <>minChoices;

	*new { arg list, repeats=1, memSize=1, minChoices=1;
		^super.newCopyArgs(list, repeats, memSize, minChoices);
	}

	embedInStream { arg inval;
		var nlast=[], allowed, thisVal, memSizeVal;

		repeats.value.do({
			memSizeVal = memSize.value; 
			memSizeVal = memSizeVal.floor + memSizeVal.frac.coin.binaryValue;
			memSizeVal = memSizeVal.asInteger.min(list.size - minChoices);
			allowed = list.difference(nlast);
			thisVal = allowed.choose;
			nlast = nlast.addFirst(thisVal).keep(memSizeVal);
			inval = thisVal.embedInStream(inval);
		});
		^inval;
	}
}

Pwxnrand : ListPattern {
	var <>weights, <>memSize, <>minChoices;

	*new { arg list, weights, repeats=1, memSize=1, minChoices=1;
		^super.newCopyArgs(list, repeats, weights, memSize, minChoices);
	}

	embedInStream { arg inval;
		var nlast=[], allowed, allowWeights, thisVal, memSizeVal;

		repeats.value.do({
			memSizeVal = memSize.value; 
			memSizeVal = memSizeVal.floor + memSizeVal.frac.coin.binaryValue;
			memSizeVal = memSizeVal.asInteger.min(list.size - minChoices); 
			
			allowed = []; 
			allowWeights = [];
			list.do { |el, i| 
				if (nlast.includes(el).not) { 
					allowed = allowed.add(el);
					allowWeights = allowWeights.add(weights[i]);
				}
			};
			
			[ allowed, allowWeights, allowWeights.normalizeSum].round(0.001).postln;
			
			thisVal = allowed.wchoose(allowWeights.normalizeSum);
			nlast = nlast.addFirst(thisVal).keep(memSizeVal);
			inval = thisVal.embedInStream(inval);
		});
		^inval;
	}
}
