// stream implementation of lindenmeyer systems, depth first traversal
// a stream of strings, symbols or characters is recursively rewrittenten 
// into a stream of characters
// version 1.1, 18.02.2005 

// the rules can use strings, strings, chars or functions as values


+ Stream {
	
	// a stream of strings or characters
	
	rewriteString { arg rules, level=1, contextSize;
		if(level > 0) {
			
			if(contextSize.isNil) {	
				contextSize = 1;
				rules.keysDo { |key| contextSize = max(contextSize, key.size) };
			};

			^Routine { arg inval;
				var outval, key, current, rewritten;
			 	
				current = "";
				
				loop {
					outval = this.next(inval);
					
					if(outval.notNil) {
						current = current ++ outval;
						// current.postln;
					} {
						if(current.size < 1) { nil.alwaysYield };
					};
					if( current.size >= contextSize or: { outval.isNil } ) {
						#key, rewritten = current.matchRules(rules);
						if(key.notNil) {
							
						//	[key, rewritten, current].postln;
	
							rewritten = rewritten.value(current, level, rules);
							rewritten.do { |el|inval = el.yield };
							current = current.drop(key.size);

							key = nil;
						} {
							current.removeAt(0).yield;
						}
					};
				};
				
			}.rewriteString(rules, level - 1, contextSize)
		}
	}
}


+ String {
	
	
	
	matchRules { arg rules; // returns [key, value] pair
			var maxSize;
			rules.keysValuesDo { |key, value|
					if(this.beginsWith(key)) { ^[key, value] }
			}
			^#[]
	}
	
	rewriteString { arg rules, level=1, contextSize; // the whole string is rewrittenten at once
		^all(Routine.new { this.do(_.yield) }.rewriteString(rules, level, contextSize)).join
	}
	
}


// dictionary compatibility

+ Collection {
		
	keysValuesDo { arg func;
		this.do { | assoc |
			func.value(assoc.key, assoc.value)
		}
	}
	keysDo { arg func;
		this.do { | assoc, i |
			func.value(assoc.key, i)
		}
	}
	
}


