	// open a textfile, read it line by line;
	// find simple ways to parse each line differently. 
LineReader { 
	classvar <keyValFunc; 
	var <stream;
	var <>skipEmpty = false;
	
	*initClass { 	// pass in a line and get it split into key and value.
		keyValFunc = { |line, i|
			var key, val;
			if (line.notNil and: { line.notEmpty }, { 
				#key, val = line.split($=); 
				if (key.last == $ ) { key = key.drop(-1) }; 
				key = key.asSymbol;
				val = try { val.interpret } { val };
				[key, val]
			});
		};
	}
	
	*new { arg stream;
		^super.newCopyArgs(stream)
	}
	*readAll { |path, func, skipEmpty=false| 
		^this.new
			.skipEmpty_(skipEmpty)
			.open(path)
			.readAll(func)
	}
	
	*open { |path| ^this.new.open(path) }
	
	open { |path| 
		stream = File(path, "r");
		if (stream.isOpen.not) { 
			warn("LineReader: file" + path + "not found.");
			^false 
		};
		^this
	}
	
	close { stream.close }
	
	*read { |path, skipEmpty=false, func| 
		^this.new.open(path);
	}
	
	readLine { |func|
		var line = stream.getLine;
		^if (func.isNil, line, { func.value(line) });
	}
	readLines { |n=1, func| 
		var line, lines, count = 0; 
		if (skipEmpty.not, { 
			n.do { |i| 
				line = stream.getLine; 
				lines = lines.add( if (func.isNil, line, { func.value(line, i) }));
			};
			^lines;
		}, { 
		//	"skipEmpty...".postln;
			while { 
				line = stream.getLine;
				line.notNil and: { count < n }
			} { 
				count = count + 1;
				lines = lines.add( if (func.isNil, line, { func.value(line, count) }));
			};
			^lines;
		});
	}
	readAll { |func| 
		var line, lines, count=0; 
		func = func ? { |line| line };
		while { 
			line = stream.getLine;
			line.notNil;
		} { 
			if (skipEmpty.not or: { line != "" }, { 
				lines = lines.add(func.value(line, count));
				count = count + 1;
			});
		};
		// ("read" + count + "lines.").postln;
		^lines;
	}
}
