+ SequenceableCollection { 
	cubicAt { |index, method = \clipAt| 
		var indices, frac;
		var y0, y1, y2, y3; 
		var c0, c1, c2, c3; 
				// ugly way to get expansion
		if (index.isKindOf(Collection), { 
			^index.collect(this.cubicAt(_, method))
		}, { 
			indices = index.trunc.asInteger + [-1,0,1,2];
			frac = index.frac;
			
			#y0, y1, y2, y3 = this.perform(method, indices);
			
			c0 = y1; 
			c1 = 0.5 * (y2 - y0);
			c2 = y0 - (2.5 * y1) + (2.0 * y2) - (0.5 * y3);
			c3 = (0.5 * (y3 - y0)) + (1.5 * (y1 - y2));
			
			^((c3 * frac + c2) * frac + c1) * frac + c0;
		});
	}
	
	resamp3 { arg newSize, method = \clipAt;
		var factor = this.size - 1 / (newSize - 1);
		^this.species.fill(newSize, { |i| this.cubicAt(i * factor, method) })
	}

		// even smoother:
//	sincAt { |index, numTaps=5, method = \clipAt|
//		
//	}
}

/* 
a = [1,2,2,1,1,2,1,0]; 
a.plot;

	// linear interpolation with blendAt (plot does that anyway
b = (0,0.01..7).collect { |i| a.blendAt(i) }; 
b.plot;

	// cubic interpolation with cubicAt using clipAt for borders
b = (0,0.01..7).collect { |i| a.cubicAt(i) };
b.plot("interpol value range:" + [ b.maxItem, b.minItem ]);
[ b.maxItem, b.minItem ];	// interpol overshoots value range of array.

	// same with list for index
a.cubicAt((0,0.01..7)).plot;


		// behaviour near zero and end with clipAt
b = (-1, -0.99..8).collect { |i| a.cubicAt(i, \clipAt); };
b.plot("interpol value range:" + [ b.maxItem, b.minItem ]);

		// left of zero with foldAt
b = (-1, -0.99..8).collect { |i| a.cubicAt(i, \foldAt); };
b.plot("interpol value range:" + [ b.maxItem, b.minItem ]);
[ b.maxItem, b.minItem ];

		// left of zero with wrapAt 
b = (-1, -0.99..8).collect { |i| a.cubicAt(i, \wrapAt); };
b.plot("interpol value range:" + [ b.maxItem, b.minItem ]);
[ b.maxItem, b.minItem ];

compare with sinusoid: 

a = [-1, 1].wrapExtend(16);
i = (0, 0.02..15);
b = a.cubicAt(i, \wrapAt); 
b.plot;
c = i.collect {|x| (x * -pi).cos.neg };
c.plot;
(b - c).plot;

*/

/*** based on this c function from DelayUGens.cpp: 

static float cubicinterp(float x, float y0, float y1, float y2, float y3)
{
	// 4-point, 3rd-order Hermite (x-form)
	float c0 = y1;
	float c1 = 0.5f * (y2 - y0);
	float c2 = y0 - 2.5f * y1 + 2.f * y2 - 0.5f * y3;
	float c3 = 0.5f * (y3 - y0) + 1.5f * (y1 - y2);

	return ((c3 * x + c2) * x + c1) * x + c0;
}
***/