/*
 *	JFont
 *	(SwingOSC classes for SuperCollider)
 *
 *	Replacement for the cocoa font class.
 *
 *	@author		SuperCollider Developers, Hanns Holger Rutz
 *	@version		0.3, 11-Nov-05
 */
JFont {
	classvar <>verbose = false;

	classvar <>default;
					  // JJJ
	var <>name, <>size, <>style;
		
	// JJJ
	*initClass {
		default = JFont( "Helvetica", 12 );
	}
		
	*new { arg name, size, style = 0;
		^super.newCopyArgs( name, size, style );
	}
	setDefault { default = this }
	
	*availableFonts {
		// returns an Array of font names.
		"JFont.availableFonts : not yet implemented".error;
		^nil;
//		_Font_AvailableFonts
//		^this.primitiveFailed
	}
	*antiAliasing_ { arg flag = false;
		if( verbose, { "JFont.antiAliasing : has no effect".error; });
//		_Font_SetAntiAliasing;
//		^this.primitiveFailed
	}
	*smoothing_ { arg flag = false;
		if( verbose, { "JFont.smoothing : has no effect".error; });
//		_Font_SetSmoothing;
//		^this.primitiveFailed
	}
	// JJJ
	storeArgs { ^[ name, size, style ] }
}

