package de.sciss.swingosc;

import java.awt.*;
import javax.swing.*;

public class Frame
extends JFrame
{
	private Icon icon = null;
	
	public Frame()
	{
		super();
		init();
	}
	
	public Frame( GraphicsConfiguration gc )
	{
		super( gc );
		init();
	}
	
	public Frame( String title )
	{
		super( title );
		init();
	}

	public Frame( String title, GraphicsConfiguration gc )
	{
		super( title, gc );
		init();
	}
	
	private void init()
	{
		setContentPane( new ContentPane() );
	}
	
	public void setIcon( Icon icon )
	{
		this.icon = icon;
		repaint();
	}
	
	public Icon getIcon()
	{
		return icon;
	}

//	public void paint( Graphics g )
//	{
//		super.paint( g );
//		
//		if( icon != null ) {
//			icon.paintIcon( this, g, 0, 0 );
//		}
//	}
	
	private class ContentPane
	extends JPanel // JComponent
	{
		private ContentPane()
		{
			super();
			setOpaque( true );
		}

		public void paintComponent( Graphics g )
		{
			super.paintComponent( g );
			
			if( icon != null ) {
				icon.paintIcon( this, g, 0, 0 );
			}
		}
	}
}
