
PlayPause {

	var <>playButton, <>stopButton, <>states, <>name, <>action, <model;
	
	*new { | win, rect |
		^super.new.init(win, rect)
	}
	
	init { | win, rect |
		playButton = SCButton(win, rect.resizeBy(-20,0))
					.action_({ | view | var val, msg;
						val = view.value;
						[ {model.stop; CmdPeriod.remove(this)},
						  {model.play.postln; CmdPeriod.add(this)},
						  {model.pause},
						  {model.resume; view.value = 1 }
						][val].value;
					});		
		stopButton = SCButton(win, Rect(rect.right - 20, 0, 20, rect.height))
					.states_( [ [" []", Color.red,Color(0.2,0.2,0.2,1)] ])
					.action_({ | view | playButton.valueAction_(0)});
		this.string_(" > ");
	}
	
	string_ { | argName, letterWidth = 10|
		var bounds, stringWidth;
		name = argName.asString;
		states = [
			[name, Color.green,Color(0.2,0.2,0.2,1)],
			[name, Color.yellow,Color(0.2,0.2,0.2,1)],
			[name, Color.new255(100, 200, 100),Color(0.2,0.2,0.2,1)], 
			[name, Color.green,Color(0.2,0.2,0.2,1)]]
		;
		playButton.states = states;
		stringWidth = name.size * letterWidth;
		bounds = playButton.bounds;
		bounds.width = stringWidth;
		playButton.bounds_(bounds);
		bounds = stopButton.bounds;
		bounds.left = stringWidth;
		stopButton.bounds_(bounds);

	}
	
	remove {
		"removing".postln;
		super.remove;
		playButton = nil;
		stopButton = nil;
	}
	
	cmdPeriod { playButton.valueAction_(0); }

	model_ { |  m | var pb, w, ctl;
		pb = playButton;
		model = m;
		ctl = SimpleController(model).put(\synch, { |m,c, v| 			pb.value = v;
			if (v == 0) {
				CmdPeriod.remove(this) 
			} {
				if (v==1) { CmdPeriod.add(this) }
			};
		});

		pb.onClose = {ctl.remove };		
	} 
}

