
TaskWithStreamKill {
	var <>func, <>clock, <>quant, player;
	*new { |func, clock, quant|
		^super.newCopyArgs(func, clock? TempoClock.default, quant? 0)
	}
	
	play { player = Task(func).play(clock, false, quant) }
	stop { player.stop; player.originalStream.stop; }
	pause { player.pause }
	resume { player.resume }
}

PatternPlayer {
	var <>pattern, <>clock, <>event, <>quant, eventStreamPlayer;
	
	*new { |pattern, clock, event, quant| 
		^super.newCopyArgs(pattern, clock ? TempoClock.default, event ? Event.default, quant ? 0)
	}
	
	play {
		eventStreamPlayer = pattern.play(clock, event, quant)
	}
	
	pause { eventStreamPlayer.pause }
	resume { eventStreamPlayer.resume }
	stop { eventStreamPlayer.stop; eventStreamPlayer = nil }
}

ActionPlayer {
	var <>playFunc, <>stopFunc, <>pauseFunc, <>resumeFunc;
	
	*new { |play, stop, pause, resume| ^super.newCopyArgs(play, stop, pause, resume) }
	
	play { this.playFunc.value }
	stop { this.stopFunc.value }
	pause { this.pauseFunc.value }
	resume { this.resumeFunc.value }

}