Settings {
	var <>event;
	
	*new { | event |
		^super.new.event_(event ? currentEnvironment);
	}
  
	loadDialog { 		
		File.openDialog(event.path, {arg path;  event.load(path) })
	}
	
	saveDialog {
		File.saveDialog(event.path, event.path, { arg path; event.save(path)})
	}
	
  	draw { |win, name =">", preset|
		SCButton(win, Rect(0,0,20,20))
			.states_([["sv"]])
			.action_( { event.save });
		SCButton(win, Rect(0,0,20,20))
			.states_([["ld"]])
			.action_( { event.load });
	}
	input {^nil}
	input_{}
	value{^nil}
	value_{}
}

Presets : Settings {
	var <keys;
	var cvs;
	var <presets;
	var preset;
	var <>presetCV;
		
	*new { | argKeys, event |
		 ^super.new(event).init(argKeys);
	}
	
	init { | argKeys|
		var preset;
		preset = this;
		presetCV = CV.new.sp(0,0,0,1);
		presetCV.action_({ |cv| preset.set(cv.value)});
		this.keys_(argKeys ? event.valueItems);
	}		
			
		
	draw { |win, name =">", preset|
		SCButton(win, Rect(0,0,20,20))
			.states_([["sv"]])
			.action_( { event.save });
		SCButton(win, Rect(0,0,20,20))
			.states_([["ld"]])
			.action_( { event.load });
		SCButton(win, Rect(0,0,20, 20))
			.states_([["+"]])
			.action_({preset.add; presetCV.value_(presets.size - 1)});
		SCButton(win, Rect(0,0,20, 20))
			.states_([["-"]])
			.action_({preset.remove(presetCV.value); });

		SCButton(win, Rect(0,0,20, 20))
			.states_([["<"]])
			.action_({preset.presetCV.value = presetCV.value - 1 mod: preset.presets.size});
		SCButton(win, Rect(0,0,20, 20))
			.states_([[">"]])
			.action_({preset.presetCV.value = presetCV.value + 1 mod: preset.presets.size});
		
		~numberBox.value(win, name, presetCV, ~smallNumericalRect.value);
		
	}
	presets_ { | argPresets|
		presets = argPresets;
		presetCV.spec.maxval = presets.size;
	}
	
	keys_ { | argKeys |
		cvs = argKeys.collect { |key| event[key] };
		keys = argKeys;
	}
	
	input_ { | input |
		input.do { |in, i|	cvs[i].input_(in)}
	}
	
	input { 
		^cvs.collect{|cv| cv.input }
	}
		
	add { 	
		this.presets = presets.add(this.input); 
	}
	
	remove { arg index;
		if (presets.notNil, {
			presets.removeAt(index);
			this.presets = presets;
		});
	}

	set { arg index;
		var preset;
		preset = presets[index];
		cvs.do { | p, i | p.input_(preset[i]) }
	}
	
	value {
		^[keys, presets];
	}
	
	value_ { | v|
		this.keys_(v[0]);
		this.presets_(v[1]);
	}	
}

Interpolator : Presets {
	var <>target;
	var <>base;
	var <>targetCV;
	var <>interpCV;
		
	init { |argKeys|
		var preset;
		preset = this;
		presetCV = CV.new.sp(0,0,0,1);
		presetCV.action_({ |cv| preset.set(cv.value)});
		this.keys_(argKeys ? event.valueItems);
		targetCV = CV(presetCV.spec);
		targetCV.action_({|cv| preset.setTarget(cv.value) });
		interpCV = CV(\unipolar,0);
		interpCV.action_({|cv| preset.interpolate(cv.value) });
	}
	
	setTarget { arg index;
		var currentGoal, currentPreset;
		currentGoal = presets[index];
		currentPreset = this.input;
		base = 2 * currentPreset - currentGoal;
		target = currentGoal - currentPreset;
		interpCV.value_(0); 
		
	}

	interpolate { arg index;
		if (target.notNil, {
			this.input_((index + 1) * target + base);
		})
	}
		
	draw { |win, name, preset|
		super.draw(win, name, preset);
		~slider.value(win, name, interpCV, Rect(0,0,400,20)).postln;
		~numberBox.value(win, name, targetCV, ~smallNumericalRect.value);
		SCButton(win, Rect(0,0,20, 20))
			.states_([["<"]])
			.action_({preset.targetCV.value = targetCV.value - 1 mod: preset.presets.size});
		SCButton(win, Rect(0,0,20, 20))
			.states_([[">"]])
			.action_({preset.targetCV.value = targetCV.value + 1 mod: preset.presets.size});
		
	}
}	
