
PatPlayer : ClientNode  {
	var <>pattern, <>event, <>clock, <>quant, <>target, <>addAction, <>stream;
	*new { arg pattern, event, clock, quant, target, addAction = 0;
		^super.newCopyArgs( 0, nil, target, addAction,
			 "", pattern, event ? Event.default, clock ? TempoClock.default, quant ? 1)
	}
	
	play { arg sendFlag;
		stream = pattern.play(clock, 
			event.copy
				.put(\clock, clock)
				.put(\group, target.asTarget.nodeID)
				.put(\server, target.asTarget.server)
				.put(\addAction, addAction ),
			quant);
		super.play;
	}	
	
	pause { stream.pause; super.pause; }
	resume { stream.resume; super.resume; }
	stop { stream.stop; super.stop; stream = nil; }
	
	replace { arg pat;
		pattern = pat;
		if (stream.notNil, { 
			stream.stop; 
			stream = pattern.play(clock, 
			event.copy
				.put(\clock, clock)
				.put(\group, target.asTarget.nodeID)
				.put(\server, target.asTarget.server)
				.put(\addAction, addAction)
				.put(\player,NotePlayer.new),
			quant);
		});
	}
}

TaskPlayer : ClientNode {
	var <>task, <>clock, <>quant;
	
	*new { arg func, clock, quant, target, addAction; 
		^super.newCopyArgs(0, nil, target ? RootNode(Server.default),addAction ? \addToTail)
			.clock_(clock).quant_( quant? 0.01).init(func);
	}
	
	init { arg func; task = Task(func) }
	
	play { arg sendFlag; task.play(clock,true, quant); super.play; } 
	stop { task.stop; super.stop }
	pause { task.pause; super.pause }
	resume { task.resume; super.resume }

}

NodeProxyPlayer : TaskPlayer {
	var <>nodeProxy, <>args;
	*new { arg func, args, clock, quant, target, addAction; 
		^super.new(func, clock, quant, target, addAction).args_(args)	}
	init { arg func;
		nodeProxy = NodeProxy.audio(Server.default, 2);
		task = Task({ func.value(nodeProxy) });
	}
	
	play { 
		nodeProxy.awake = true; 
		nodeProxy.wakeupInGroup(target.asGroup); 
		nodeProxy.play(group: target.asGroup); 
		super.play;
		nodeProxy.setControls(args.value);
	}
	stop { arg sendFlag = true; 
		if (sendFlag, { 
			nodeProxy.clear;		
		}); super.stop 
	}
	pause { arg sendFlag = true; if (sendFlag, { nodeProxy.group.run(false) }); super.pause }
	resume { arg sendFlag = true; if (sendFlag, { nodeProxy.group.run(true) }); super.resume }
		
	
}

