// Display is a ControlEnvironment that can create a GUI

Display  : ControlEnvironment  {
	
	var <>guiItems;
	var <>stopOnClose;
	var <>views;					// actual gui items	
	init { arg args;
		clientgroup = ClientGroup.new;
		args.do({ | c | this.put(c.name, c) });
		valueItems = args;
		guiItems = [clientgroup] ++ args;
		stopOnClose = true
	}
		
	installMakeFuncArgs { arg args;
		valueItems = valueItems ++ args;
		guiItems = guiItems ++ args;
		^args
	}
	
	show { arg argName, x = 128, y = 64, w = 660, h = 160;
		var win, bounds;
		
		win = ModelWindow(argName ? "", Rect(x,y,w,h));
		win.view.decorator = FlowLayout(win.view.bounds);
		bounds = win.bounds;

		SimpleController(win).put(\close, { this.remove });

		this.draw(win);
		bounds.height = win.view.decorator.top + 16;
		win.bounds_(bounds);
		win.front;
		^win;
	}
	
	remove {			
		views.do({arg v;  v.remove; }); 	// before stopping
		views = nil;
		if (stopOnClose == true, { 		// so deferred synch messages
			this.stop; 				// don't update deleted
		});							// dependants
	}
	
	
	draw { arg win;
		guiItems
		.do({arg v;
			v.asArray.do({ arg v; views = views.add(v.draw(win)) }); 
			win.view.decorator.nextLine;
			v.update(this,\synch); 
		});
	}	

}


/*
s.boot;

SynthDef("SimplePM", { arg f =100,a=0.1, theIndex= 2,r=2;
	Out.ar(0,SinOsc.ar(f,SinOsc.ar(f*r,0,theIndex),a))
}).writeDefFile.send(s);

a = Preset.make({ arg e,a, q,f, r, theIndex, fa;
	f		.spec_(\freq,600);					// set the specs for the ControlValues
	r		.spec_([0,10,'lin',0,1]);
	theIndex	.spec_([0,10,'lin',0,1]);
	a		.spec_(\amp);
	fa		.spec_(\amp);
	e.synth_("SimplePM",[f,r,theIndex, a]);
});
a.show;
ControlValue

*/