//SLUGens released under the GNU GPL as extensions for SuperCollider 3, by Nick Collins, http://www.cus.cam.ac.uk/~nc272/

SortBuf : UGen
{
	*ar { arg bufnum=0, sortrate=10, reset=0;
		^this.multiNew('audio', bufnum,sortrate,reset);
	}
}


GravityGrid : UGen
{
	*ar { arg reset=0, rate=0.1, newx=0.0, newy=0.0, bufnum, mul = 1.0, add = 0.0;
		^this.multiNew('audio', reset,rate,newx,newy,bufnum? (-1)).madd(mul, add);
	}
}


//bufnum, 0 capturein 1, capturetrigger 2, duration of repeat 3, ampdropout 4
Breakcore : UGen
{
	*ar { arg bufnum=0, capturein, capturetrigger, duration=0.1, ampdropout;
		^this.multiNew('audio', bufnum, capturein, capturetrigger, duration, ampdropout);
	}
}


//find max amplitude over time
Max : UGen
{
	*kr { arg in, numsamp=64;
		^this.multiNew('control', in, numsamp);
	}
}


//print value every x blocks
PrintVal : UGen
{
	*kr { arg in, numblocks=100, id=0;
		^this.multiNew('control', in, numblocks, id);
	}
}

//envelope detection filter from musicdsp.org
EnvDetect : UGen
{
	*ar { arg in, attack=100, release=0;
		^this.multiNew('audio', in, attack, release);
	}
}

FitzHughNagumo : UGen
{
	*ar { arg reset=0, rateu=0.01, ratew=0.01, b0=1, b1=1, initu=0, initw=0, mul = 1.0, add = 0.0;
		^this.multiNew('audio', reset,rateu, ratew, b0, b1, initu, initw).madd(mul, add);
	}
}


DoubleWell : UGen
{
	*ar { arg reset=0, ratex=0.01, ratey=0.01, f=1,w=0.001,delta=1, initx=0,inity=0, mul = 1.0, add = 0.0;
		^this.multiNew('audio',reset,ratex,ratey,f,w,delta,initx, inity).madd(mul, add);
	}
}


WeaklyNonlinear : UGen
{
	*ar { arg input, reset=0, ratex=1, ratey=1, freq=440,initx=0,inity=0, alpha=0, xexponent=0, beta=0, yexponent=0, mul = 1.0, add = 0.0;
		^this.multiNew('audio',input,reset,ratex,ratey,freq,initx, inity, alpha, xexponent, beta, yexponent).madd(mul, add);
	}
}


