
// how to get things into a SeqBuilder

+ MIDIRecSocket {
	draggedIntoSeqBuilder { arg dest, putMethod;
		var	getMethods, seq;
		seq = this.asNoteSequence ?? { ^nil };	// error trapping: stop on nil
		getMethods = IdentityDictionary[
			\pitch_ -> { seq.origFreqs },
			\dur_ -> { seq.origDurs },
			\length_ -> { seq.origLengths },
			\args_ -> { seq.origArgStreams }
		];
		(putMethod == \all_).if({
			dest.all_(seq.origFreqs, seq.origDurs, seq.origLengths, seq.absLengths,
				seq.maxPlayBeats, seq.origArgStreams);
		}, {
			dest.perform(putMethod, getMethods[putMethod].value);
		});
	}
}

//+ NoteSequence {
//	draggedIntoSeqBuilder { arg dest, putMethod;
//		var	getMethods;
//		getMethods = IdentityDictionary[
//			\pitch_ -> { this.origFreqs },
//			\dur_ -> { this.origDurs },
//			\length_ -> { this.origLengths },
//			\args_ -> { this.origArgStreams }
//		];
//		(putMethod == \all_).if({
//			dest.all_(this.origFreqs, this.origDurs, this.origLengths, this.absLengths,
//				this.maxPlayBeats, this.origArgStreams);
//		}, {
//			dest.perform(putMethod, getMethods[putMethod].value);
//		});
//	}
//}

+ Pattern {	// what should pattern do for args?
	draggedIntoSeqBuilder { arg dest, putMethod;
		(putMethod == \all_).if({
			"Can't do that: Patterns should only be put in sequence components.".warn
		}, {
			dest.perform(putMethod, this)
		});
	}
}

+ SequenceableCollection {
	draggedIntoSeqBuilder { arg dest, putMethod;
		(putMethod == \all_).if({
			"Can't do that: Arrays should only be put in sequence components.".warn
		}, {
			(putMethod == \args_).if({
				dest.perform(putMethod, this)
			}, {
				dest.perform(putMethod, Pseq(this, inf))  // Array -> infinite Pseq
			});
		});
	}
}

+ SimpleNumber {	// what should number do for args?
	draggedIntoSeqBuilder { arg dest, putMethod;
		(putMethod == \all_).if({
			"Can't do that: Numbers should only be put in sequence components.".warn
		}, {
			dest.perform(putMethod, (putMethod == \length_).if({
				this
			}, {
				Pseq([this], inf)  // number -> infinite Pseq
			}));
		});
	}
}

+ Nil {	// dragging nil also a component to be cleared for further concatenation
	draggedIntoSeqBuilder { arg dest, putMethod;
		(putMethod == \all_).if({
			dest.all_(nil, nil, nil, true, nil);	// reset
		}, {
			dest.perform(putMethod, nil)
		});
	}
}
