
	// some new patterns - jamshark70@dewdrop-world.net

Pwxrand : ListPattern {
	var <weights;
	*new { arg list, weights, repeats=1;
		^super.new(list, repeats).weights_(weights)
	}
	weights_ { arg w;
		(w.size > 1).if({ weights = w },
				// why? if only 1, a value must be repeated and that's not OK here
			{ "Weights array in Pwxrand must have at least 2 elements.".die(w) });
	}
	asStream { 
		^Routine.new({ arg inval;
			var item, lastValue;
			item = lastValue = 0;
			repeats.value.do({ arg i;
//"Pwxrand-stream".postln;
				{ item == lastValue }.while({ item = list.at(weights.windex); });
				lastValue = item;
				inval = item.embedInStream(inval);
			});
		});
	}
	storeArgs { ^[ list, weights, repeats ] }
}

PslideNoWrap : Pslide {
    embedInStream { arg inval;
	    	var item;
	    	var pos = start; 
	    	repeats.do({
	    		len.do({ arg j;
	    			(item = list.at(pos + j)).isNil.if({ ^inval });
	    			inval = item.embedInStream(inval);
	    		});
	    		pos = pos + step;
	    	});
	     ^inval;  		
    }
}

Pslide1 : Pslide {
    embedInStream { arg inval;
	    	var pos, item, lenStream, stepStream;
	    	pos = start;
	    	lenStream = PollStream(len);
	    	stepStream = PollStream(step);
	    	repeats.do({
	    			// nil protection -- stop immediately if lenStream or stepStream return nil
	    		lenStream.next.notNil.if({
		    		lenStream.poll.do({ arg j;
		    			item = list.wrapAt(pos + j);
		    			inval = item.embedInStream(inval);
		    		});
		    		stepStream.next.notNil.if({ pos = pos + stepStream.poll },
		    			{ ^inval });
		    	}, { ^inval });
	    	});
	     ^inval;  		
    }
}

PseqFunc : Pseq {
		// executes a function on the list item before embedding in stream
		// if func is nil, the item is used as is
	var	<func;
	
	*new { |list, repeats = 1, offset = 0, func|
		^super.new(list, repeats, offset).func_(func)
	}
	
	func_ { |f|
		f.isNil.if({ func = { |x| x } }, { func = f });
	}
	
	embedInStream {  arg inval;
		var item, offsetValue;
		offsetValue = offset.value;
		if (inval.eventAt('reverse') == true, {
			repeats.value.do({ arg j;
				list.size.reverseDo({ arg i;
					item = func.value(list.wrapAt(i + offsetValue));
					inval = item.embedInStream(inval);
				});
			});
		},{
			repeats.value.do({ arg j;
				list.size.do({ arg i;
					item = func.value(list.wrapAt(i + offsetValue));
					inval = item.embedInStream(inval);
				});
			});
		});
		^inval;
	}
}

PserFunc : PseqFunc {
	embedInStream {  arg inval;
		var item, offsetValue;
		offsetValue = offset.value;
		if (inval.eventAt('reverse') == true, {
			repeats.value.reverseDo({ arg i;
				item = func.value(list.wrapAt(i + offsetValue));
				inval = item.embedInStream(inval);
			});
		},{
			repeats.value.do({ arg i;
				item = func.value(list.wrapAt(i + offsetValue));
				inval = item.embedInStream(inval);
			});
		});
		^inval;
	}
}
