
MonoPortaSynthVoicerNode : SynthVoicerNode {

	trigger { arg freq, gate = 1, args, latency;
		var bundle;
		synth.notNil.if({
			bundle = this.setMsg([\freqlag, voicer.portaTime, \freq, freq,
				\gate, gate, \t_gate, gate] ++ args);
		}, {
			bundle = this.triggerMsg(freq, gate, [\freqlag, voicer.portaTime] ++ args);
			NodeWatcher.register(synth);
		});
//bundle.asCompileString.postln;
		target.server.listSendBundle(myLastLatency = latency, bundle);
		frequency = freq;	// save frequency for Voicer.release
		voicer.lastFreqs.add(freq);
		lastTrigger = Main.elapsedTime;	// save time
//		isPlaying = true;
	}
	
	release { arg gate = 0, latency;	// release using Env's releaseNode
		this.isPlaying.if({ 
			synth.server.listSendBundle(latency, this.releaseMsg(gate));
			synth = nil;
		});
	}
	
}

MonoPortaInstrVoicerNode : InstrVoicerNode {

	trigger { arg freq, gate = 1, args, latency;
		var bundle;

//"MonoPortaInstrVoicerNode-trigger - ".post;
//[freq, gate, args, noLatency].asCompileString.postln;

		synth.notNil.if({
			bundle = this.setMsg([\freqlag, voicer.portaTime, \freq, freq,
				\gate, gate, \t_gate, gate] ++ args);
		}, {
			bundle = this.triggerMsg(freq, gate, [\freqlag, voicer.portaTime] ++ args);
		});
		
//bundle.asCompileString.postln;
		target.server.listSendBundle(myLastLatency = latency, bundle);
		
		frequency = freq;
		voicer.lastFreqs.add(freq);
		lastTrigger = Main.elapsedTime;
		isPlaying = true;
//["MonoPortaInstrVoicerNode-trigger", freq, voicer.lastFreqs].asCompileString.postln;
	}

	release { arg gate = 0, latency;
//"MonoPortaInstrVoicerNode-release - ".post;
		isPlaying.if({
//			voicer.lastFreqs.remove(frequency).postln;
//this.setMsg([\gate, gate]).postln;
			this.set([\gate, gate], latency);
			synth = nil;
			isPlaying = false;
		});
	}

}
