#include "SC_PlugIn.h"
#include "BandedWG.h"
#include "Stk.h"
#include "STKAlloc.h"

static InterfaceTable *ft;
 struct StkBandedWG : public Unit
{
	BandedWG *bandedWG;
	int		lastperiod;
	float   trig;
	float   instr; 
	float   bowpressure; 
	float   bowmotion;  
	float   integration; 
	float   modalresonance; 
	float   bowvelocity; 
	float   setstriking; 

	};
 
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkBandedWG_next(StkBandedWG *unit, int inNumSamples);
        void StkBandedWG_Ctor(StkBandedWG* unit);
        void StkBandedWG_Dtor(StkBandedWG* unit);
};

//////////////////////////////////////////////////////////////////

void StkBandedWG_Ctor(StkBandedWG* unit)
{
// p0=freq,p2=bowpressure, p3=bowmotion, p4=strikeposition, p5=vibratofreq, p6=gain, p7=bowvelocity, p8=setstriking
	
	//unit->bandedWG = new BandedWG();
	STKAlloc0(unit->mWorld,  unit->bandedWG, BandedWG);

/******
     Control Change Numbers: 
       - Bow Pressure = 2
       - Bow Motion = 4
       - Strike Position = 8 (not implemented)
       - Vibrato Frequency = 11
       - Gain = 1
       - Bow Velocity = 128
       - Set Striking = 64
       - Instrument Presets = 16
         - Uniform Bar = 0
         - Tuned Bar = 1
         - Glass Harmonica = 2
         - Tibetan Bowl = 3
 
  	unit->bandedWG->noteOn(IN0(0) ,1);
	unit->trig = 1;         
	unit->bandedWG->controlChange((int)16,unit->instr = IN0(1));     
	unit->bandedWG->controlChange((int)2,unit->bowpressure = IN0(2));// bow pressure
	unit->bandedWG->controlChange((int)4,unit->bowmotion = IN0(3)); // bow motion
	unit->bandedWG->controlChange((int)11, unit->integration = IN0(4)); // vibrato frequency?  integration
	unit->bandedWG->controlChange((int)1,unit->modalresonance = IN0(5)); // gain/ modal resonance
	unit->bandedWG->controlChange((int)128,unit->bowvelocity = IN0(6)); //bow velocity
	unit->bandedWG->controlChange((int)64,unit->setstriking = IN0(7));  // set striking
 	SETCALC(StkBandedWG_next);
	StkBandedWG_next(unit, 1);
******/

        unit->bandedWG->controlChange((int)16, IN0(1));
 
        unit->bandedWG->controlChange((int)2, IN0(2));// bow pressure
        unit->bandedWG->controlChange((int)4, IN0(3)); // bow motion
        unit->bandedWG->controlChange((int)11, IN0(4)); // vibrato frequency?  integration
        unit->bandedWG->controlChange((int)1, IN0(5)); // gain/ modal resonance
        unit->bandedWG->controlChange((int)128, IN0(6)); //bow velocity
        unit->bandedWG->controlChange((int)64, IN0(7));  // set striking
 
        unit->bandedWG->noteOn(IN0(0) ,1);
        SETCALC(StkBandedWG_next);
        StkBandedWG_next(unit, 1);

printf("%f %f %f %f %f %f %f %f\n", IN0(0),IN0(1),IN0(2),IN0(3),IN0(4),IN0(5),IN0(6),IN0(7)); 
}
            
void StkBandedWG_next(StkBandedWG *unit, int inNumSamples)
{
	float *out = OUT(0);
/**********
 	if(IN0(8) > 0) { 
		if(unit->trig < 0) {  
				unit->bandedWG->noteOff( 0);
				//unit->bandedWG->clear();
			    unit->bandedWG->noteOn(IN0(0) ,1);
printf("%f %f %f %f %f %f %f %f\n", IN0(0),IN0(1),IN0(2),IN0(3),IN0(4),IN0(5),IN0(6),IN0(7)); 
		  							
				if(unit->instr != IN0(1))  unit->bandedWG->controlChange((int)16,unit->instr = IN0(1));     
				if(unit->bowpressure != IN0(2)) unit->bandedWG->controlChange((int)2,unit->bowpressure = IN0(2));
				if(unit->bowmotion != IN0(3)) unit->bandedWG->controlChange((int)4,unit->bowmotion = IN0(3)); 
				if(unit->integration != IN0(4)) unit->bandedWG->controlChange((int)11,unit->integration = IN0(4));  
				if(unit->modalresonance != IN0(5)) unit->bandedWG->controlChange((int)1,unit->modalresonance = IN0(5));
				if(unit->bowvelocity != IN0(6)) unit->bandedWG->controlChange((int)128,unit->bowvelocity = IN0(6)); 
				if(unit->setstriking != IN0(7)) unit->bandedWG->controlChange((int)64,unit->setstriking = IN0(7));
				};
			};
	unit->trig = IN0(8);
****************/	 		
 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->bandedWG->tick();
         }
 }

void StkBandedWG_Dtor(StkBandedWG* unit)
{
	//unit->bandedWG->clear();
	//delete unit->bandedWG;
	unit->bandedWG->~BandedWG();
	RTFree(unit->mWorld, unit->bandedWG);
}

void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkBandedWG); 
}
 