#include "SC_PlugIn.h"
#include "Flute.h"

static InterfaceTable *ft;

  struct StkFlute2 : public Unit
{
	Flute *flute;
};
 
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkFlute2_next_notfull(StkFlute2 *unit, int inNumSamples);
        void StkFlute2_Ctor(StkFlute2* unit);
        void StkFlute2_Dtor(StkFlute2* unit);
};

//////////////////////////////////////////////////////////////////

void StkFlute2_Ctor(StkFlute2* unit)
{
	unit->flute = new Flute(80);
	unit->flute->noteOn(IN0(0) ,1);
	SETCALC(StkFlute2_next_notfull);
	StkFlute2_next_notfull(unit, 1);
 
}

void StkFlute2_next_notfull(StkFlute2 *unit, int inNumSamples)
{
	float *out OUT(0);
	unit->flute->controlChange(2,IN0(1));
	unit->flute->setFrequency(IN0(0));
	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->flute->tick();
        }

}

void StkFlute2_Dtor(StkFlute2* unit)
{
	delete unit->flute;
}
 
void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkFlute2);
}
