#include "SC_PlugIn.h"
#include "bowed.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.tbl"
#include "STKAlloc.h"

static InterfaceTable *ft;

  struct StkBowed2 : public Unit
{
	Bowed *bowed;
	float freq;
	float bowposition;
	float bowpressure;
	float loudness;
	float trig;
};
 
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkBowed2_next(StkBowed2 *unit, int inNumSamples);
        void StkBowed2_Ctor(StkBowed2* unit);
        void StkBowed2_Dtor(StkBowed2* unit);
};

//////////////////////////////////////////////////////////////////

void StkBowed2_Ctor(StkBowed2* unit)
{
	//Stk :: setRawwavePath("/Users/paul/stk-4.1.3/rawwaves");
/*
      - Bow Pressure = 2
       - Bow Position = 4
       //- Vibrato Frequency = 11
       //- Vibrato Gain = 1
       - Volume = 128
*/
	STKAlloc(unit->mWorld, unit->bowed, Bowed, 40);

	unit->freq = unit->bowposition = unit->bowpressure = unit->loudness = 0;
	unit->bowed->noteOn(IN0(0) ,1);
	SETCALC(StkBowed2_next);
	StkBowed2_next(unit, 1);
	unit->trig = 1;
 
}

void StkBowed2_next(StkBowed2 *unit, int inNumSamples)
{
	float *out = OUT(0);
	
	float in00=IN0(0);
	float in01=IN0(1);
	float in02=IN0(2);
	float in03=IN0(3);
 	if(IN0(4) > 0) { 
		if(unit->trig < 0) {

				unit->bowed->noteOff( 0);
			    unit->bowed->noteOn(IN0(0) ,1);
				};
			};
	unit->trig = IN0(4);
	 		
	if(in00 != unit->freq) {
		unit->bowed->setFrequency(in00);  
		unit->freq = in00;};
	
	if(in01 != unit->bowpressure) {
		unit->bowed->controlChange(__SK_BowPressure_, in01);
		unit->bowpressure = in01; };
 	
	if(in02 != unit->bowposition) {
		unit->bowed->controlChange(__SK_BowPosition_, in02);
		unit->bowposition = in02; };
 		
	if(in03 != unit->loudness) {
		unit->bowed->controlChange(__SK_AfterTouch_Cont_, in03);
		unit->loudness = in03; };

 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->bowed->tick();
        }

}
 
void StkBowed2_Dtor(StkBowed2* unit)
{
	//delete unit->bowed;
	unit->bowed->~Bowed();
    RTFree(unit->mWorld, unit->bowed);

}
 
void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkBowed2);
}
