#include "SC_PlugIn.h"
#include "Flute.h"
#include "STKAlloc.h"
//  Am replacing old StkFlute2 with StkFlute
static InterfaceTable *ft;

  struct StkFlute : public Unit
{
	Flute *flute;
	float jetdelay;
	float noisegain;
	float vibfreq;
	float vibgain;
	float breathpressure;
	float freq;
	float trig;
};
 
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkFlute_next(StkFlute *unit, int inNumSamples);
        void StkFlute_Ctor(StkFlute* unit);
        void StkFlute_Dtor(StkFlute* unit);
};

//////////////////////////////////////////////////////////////////

void StkFlute_Ctor(StkFlute* unit)
{
	STKAlloc(unit->mWorld, unit->flute, Flute, 40);
 
	unit->flute->controlChange(2, unit->jetdelay = IN0(1));// jet delay
	unit->flute->controlChange(4, unit->noisegain = IN0(2));// noisegain
	unit->flute->controlChange(11, unit->vibfreq = IN0(3));// vibrato freq
	unit->flute->controlChange(1, unit->vibgain = IN0(4));// vibrato gain
	unit->flute->controlChange(128, unit->breathpressure = IN0(5));	// breathpressure
	unit->flute->noteOn(IN0(0),1);
    unit->freq = IN0(0);
	SETCALC(StkFlute_next);

	StkFlute_next(unit, 1);
	unit->trig = 1;
}

void StkFlute_next(StkFlute *unit, int inNumSamples)
{
	float *out OUT(0);
 
 	if(IN0(6) > 0) { 
		if(unit->trig < 0) {  

			unit->flute->noteOff(0);
			unit->flute->noteOn(IN0(0) ,1);
			
		}; 
			};
	unit->trig = IN0(6);

	if(unit->freq != IN0(0)) unit->flute->setFrequency(unit->freq = IN0(0));

	if(unit->jetdelay != IN0(1)) unit->flute->controlChange(2, unit->jetdelay = IN0(1));
	if(unit->noisegain != IN0(2)) unit->flute->controlChange(4, unit->noisegain = IN0(2));
	if(unit->vibfreq != IN0(3)) unit->flute->controlChange(11, unit->vibfreq = IN0(3));
	if(unit->vibgain != IN0(4)) unit->flute->controlChange(1, unit->vibgain = IN0(4));
	if(unit->breathpressure != IN0(5)) unit->flute->controlChange(128, unit->breathpressure = IN0(5));
	
	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->flute->tick();
        }

}

void StkFlute_Dtor(StkFlute* unit)
{
	//delete unit->flute;
	unit->flute->~Flute();
    RTFree(unit->mWorld, unit->flute);
}
 
void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkFlute);
}
