#include "SC_PlugIn.h"
#include "Mandolin.h"
#include "STKAlloc.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.tbl"
#include "Stk.h"
 
static InterfaceTable *ft;
// p0=freq, p1 = bodysize, p2=pluckposition, p3=stringdamping, p4=stringdetune, p5=aftertouch
 
struct StkMandolin : public Unit
{
	Mandolin *mandolin;
	float bodysize;
	float pickposition;
	float stringdamping;
	float stringdetune;
	float aftertouch;
	float trig;
 };
   
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkMandolin_next(StkMandolin *unit, int inNumSamples);
        void StkMandolin_Ctor(StkMandolin* unit);
        void StkMandolin_Dtor(StkMandolin* unit);
};
 
//////////////////////////////////////////////////////////////////

void StkMandolin_Ctor(StkMandolin* unit)
{

	//unit->mandolin = new Mandolin((MY_FLOAT) 40);
	STKAlloc(unit->mWorld, unit->mandolin, Mandolin, 40);

	
	unit->mandolin->controlChange(__SK_BodySize_, unit->bodysize = IN0(1));
	unit->mandolin->controlChange(__SK_PickPosition_, unit->pickposition = IN0(2));
	unit->mandolin->controlChange(__SK_StringDamping_, unit->stringdamping = IN0(3));
	unit->mandolin->controlChange(__SK_StringDetune_, unit->stringdetune = IN0(4));
	unit->mandolin->controlChange(__SK_AfterTouch_Cont_, unit->aftertouch = IN0(5));
	unit->trig = 1;
	unit->mandolin->noteOn(IN0(0) ,1);
 	SETCALC(StkMandolin_next);
	StkMandolin_next(unit, 1);
 
}

void StkMandolin_next(StkMandolin *unit, int inNumSamples)
{
	float *out  = OUT(0);

 	if(IN0(6) > 0) { 
		if(unit->trig < 0) {  
			if(unit->bodysize != IN0(1)) unit->mandolin->controlChange(__SK_BodySize_, unit->bodysize = IN0(1));
			if(unit->pickposition != IN0(2)) unit->mandolin->controlChange(__SK_PickPosition_, unit->pickposition = IN0(2));
			if(unit->stringdamping != IN0(3)) unit->mandolin->controlChange(__SK_StringDamping_, unit->stringdamping = IN0(3));
			if(unit->stringdetune != IN0(4)) unit->mandolin->controlChange(__SK_StringDetune_, unit->stringdetune = IN0(4));
			if(unit->aftertouch != IN0(5)) unit->mandolin->controlChange(__SK_AfterTouch_Cont_, unit->aftertouch = IN0(5));

			unit->mandolin->noteOff( 0);
			unit->mandolin->noteOn(IN0(0) ,1);
			
		}; 
			};
	unit->trig = IN0(6);


 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->mandolin->tick();
        }
}

void StkMandolin_Dtor(StkMandolin* unit)
{
	//delete unit->mandolin;
	unit->mandolin->~Mandolin();
    RTFree(unit->mWorld, unit->mandolin);

}

void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkMandolin);
 
}
 