#include "SC_PlugIn.h"
#include "Mandolin.h"
#include "STKAlloc.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.tbl"
#include "Stk.h"
static InterfaceTable *ft;
// p0=freq, p1 = bodysize, p2=pluckposition, p3=stringdamping, p4=stringdetune, p5=aftertouch

struct StkMandolinD : public Unit
{
	Mandolin *mandolinD;
	float trig;
 };
      
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkMandolinD_next(StkMandolinD *unit, int inNumSamples);
         void StkMandolinD_Ctor(StkMandolinD* unit);
        void StkMandolinD_Dtor(StkMandolinD* unit);
};
  
//////////////////////////////////////////////////////////////////

void StkMandolinD_Ctor(StkMandolinD* unit)
{
 
	//unit->mandolinD = new MandolinD((MY_FLOAT) 40);
	STKAlloc(unit->mWorld, unit->mandolinD, Mandolin, 40);
	

	//unit->mandolinD->noteOff(0);
	unit->mandolinD->noteOn(IN0(0) ,1);
	unit->mandolinD->controlChange(__SK_BodySize_, IN0(1));
	unit->mandolinD->controlChange(__SK_PickPosition_, IN0(2));
	unit->mandolinD->controlChange(__SK_StringDamping_, IN0(3));
	unit->mandolinD->controlChange(__SK_StringDetune_, IN0(4));
	unit->mandolinD->controlChange(__SK_AfterTouch_Cont_, IN0(5));
	//printf("%d\n", unit->mandolinD->testval);
	//unit->mandolinD->testval = unit->mandolinD->testval+1;
 	SETCALC(StkMandolinD_next);
	StkMandolinD_next(unit, 1);
 	unit->trig = 1;
  
}
 
void StkMandolinD_next(StkMandolinD *unit, int inNumSamples)
{
	float *out = OUT(0);
 
 	if(IN0(6) > 0) { 
		if(unit->trig < 0) {  
				unit->mandolinD->noteOff( 0);
			    unit->mandolinD->noteOn(IN0(0) ,1);
			}; 
		};
	unit->trig = IN0(6);

 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->mandolinD->tick();
        }
}
 
void StkMandolinD_Dtor(StkMandolinD* unit)
{
	//delete unit->mandolinD;
	unit->mandolinD->~Mandolin();
    RTFree(unit->mWorld, unit->mandolinD);

}

void load(InterfaceTable *inTable)
{
		//Mandolin *tempmandolin;
        ft = inTable;
        DefineDtorUnit(StkMandolinD);
		//unit->mandolinD = new MandolinD((MY_FLOAT) 40);
		//tempmandolin = new Mandolin(((MY_FLOAT) 40));
		//tempmandolin->testval = 1945;
		//Stk::testval = 1944;
		 

}
 