#include "SC_PlugIn.h"
#include "ModalBar.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.msg"
#include "STKAlloc.h"
#include <math.h>

static InterfaceTable *ft;
 struct StkModalBar : public Unit
{
	ModalBar *modalBar;
	float   trig;
	float   instrument;
	float   stickhardness;
	float   stickposition;
	float   vibratogain;
	float   vibratofreq;
	float   directstickmix;
	float   volume;

	};

extern "C"
{
        void load(InterfaceTable *inTable);
        void StkModalBar_next(StkModalBar *unit, int inNumSamples);
        void StkModalBar_Ctor(StkModalBar* unit);
        void StkModalBar_Dtor(StkModalBar* unit);
};

//////////////////////////////////////////////////////////////////

void StkModalBar_Ctor(StkModalBar* unit)
{	
/*
    Control Change Numbers: 
       - Stick Hardness = 2
       - Stick Position = 4
       - Vibrato Gain = 11
       - Vibrato Frequency = 7
       - Direct Stick Mix = 1
       - Volume = 128
       - Modal Presets = 16
         - Marimba = 0
         - Vibraphone = 1
         - Agogo = 2
         - Wood1 = 3
         - Reso = 4
         - Wood2 = 5
         - Beats = 6
         - Two Fixed = 7
         - Clump = 8
*/

	//unit->modalBar = new ModalBar();
	STKAlloc0(unit->mWorld,  unit->modalBar, ModalBar);

	unit->modalBar->noteOn(IN0(0) ,1); 
 
	unit->modalBar->controlChange(16,unit->instrument = IN0(1));// instrument
	unit->modalBar->controlChange(2, unit->stickhardness = IN0(2));// stickhardness
	unit->modalBar->controlChange(4, unit->stickposition = IN0(3));// stickposition
	unit->modalBar->controlChange(11, unit->vibratogain = IN0(4));// vibratogain
	unit->modalBar->controlChange(7, unit->vibratofreq = IN0(5));// vibratofreq
	unit->modalBar->controlChange(1, unit->directstickmix = IN0(6));// directstickmix
	unit->modalBar->controlChange(128, unit->volume = IN0(7));// volume
  	SETCALC(StkModalBar_next);
	StkModalBar_next(unit, 1);
	unit->trig = 1;
}
   
void StkModalBar_next(StkModalBar *unit, int inNumSamples)
{
	float *out=OUT(0);

  
 	if(IN0(8) > 0) { 
		if(unit->trig < 0) {  
				unit->modalBar->clear();
				if(unit->instrument != IN0(1)) unit->modalBar->controlChange(16,unit->instrument =IN0(1));
				if(unit->stickhardness != IN0(2)) unit->modalBar->controlChange(2, unit->stickhardness =IN0(2));
				if(unit->stickposition != IN0(3)) unit->modalBar->controlChange(4,unit->stickposition =IN0(3));
				if(unit->vibratogain != IN0(4)) unit->modalBar->controlChange(11,unit->vibratogain = IN0(4));
				if(unit->vibratofreq != IN0(5)) unit->modalBar->controlChange(7,unit->vibratofreq = IN0(5));
				if(unit->directstickmix != IN0(6)) unit->modalBar->controlChange(1,unit->directstickmix =IN0(6));
				if(unit->volume != IN0(7)) unit->modalBar->controlChange(128,unit->volume  = IN0(7));
				
				unit->modalBar->noteOff( 0);
			    unit->modalBar->noteOn(IN0(0) ,1);
			
}; 
			};
	unit->trig = IN0(8);


 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->modalBar->tick();
        }
 }

void StkModalBar_Dtor(StkModalBar* unit)
{
	unit->modalBar->~ModalBar();
    RTFree(unit->mWorld, unit->modalBar);
}

void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkModalBar); 
}
 