#include "SC_PlugIn.h"
#include "Plucked.h"
#include "STKAlloc.h"

static InterfaceTable *ft;
 struct StkPluck : public Unit
{
	Plucked *pluckD;
	float trig;
};
  
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkPluck_next(StkPluck *unit, int inNumSamples);
        void StkPluck_Ctor(StkPluck* unit);
        void StkPluck_Dtor(StkPluck* unit);
};
 
//////////////////////////////////////////////////////////////////

void StkPluck_Ctor(StkPluck* unit)
{	
	STKAlloc(unit->mWorld,  unit->pluckD, Plucked,40);

	unit->pluckD->noteOn(IN0(0) ,1); 
	unit->trig = 1;
  	SETCALC(StkPluck_next);
	StkPluck_next(unit, 1);
}
  
void StkPluck_next(StkPluck *unit, int inNumSamples)
{
	float *out=OUT(0);
 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->pluckD->tick();
        }
 }

void StkPluck_Dtor(StkPluck* unit)
{
	unit->pluckD->~Plucked();
    RTFree(unit->mWorld, unit->pluckD);
}

void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkPluck); 
}
 