#include "SC_PlugIn.h"
#include "Plucked.h"
#include "STKAlloc.h"

static InterfaceTable *ft;
 struct StkPluck : public Unit
{
	Plucked *pluck;
	float trig;
};
   
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkPluck_next(StkPluck *unit, int inNumSamples);
        void StkPluck_Ctor(StkPluck* unit);
        void StkPluck_Dtor(StkPluck* unit);
};
 
//////////////////////////////////////////////////////////////////

void StkPluck_Ctor(StkPluck* unit)
{	
	STKAlloc(unit->mWorld,  unit->pluck, Plucked,40);

	unit->pluck->noteOn(IN0(0) ,1 ); 
	unit->pluck->setDecay(IN0(1));
	unit->trig = 1;
  	SETCALC(StkPluck_next);
	StkPluck_next(unit, 1);
}
  
void StkPluck_next(StkPluck *unit, int inNumSamples)
{
	float *out=OUT(0);
  
 	if(IN0(2) > 0) { 
		if(unit->trig < 0) {  
 				unit->pluck->noteOff(0);
 			    unit->pluck->noteOn(IN0(0) ,1 );
				unit->pluck->setDecay(IN0(1));
	}; 
			};
	unit->trig = IN0(2);
	
 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->pluck->tick();
        }
 }

void StkPluck_Dtor(StkPluck* unit)
{
	unit->pluck->~Plucked();
    RTFree(unit->mWorld, unit->pluck);
}

void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkPluck); 
}
 