#include "SC_PlugIn.h"
#include "Shakers.h"
#include "Stk.h"
#include "STKAlloc.h"

static InterfaceTable *ft;
 struct StkShakers : public Unit
{
	Shakers *shakers;
	float freq;
	float shakernumber;
	float energy;
	float systemdecay;
	float numobjects;
	float resfreq;
	float trigger;
	

	};

extern "C"
{
        void load(InterfaceTable *inTable);
        void StkShakers_next(StkShakers *unit, int inNumSamples);
        void StkShakers_Ctor(StkShakers* unit);
        void StkShakers_Dtor(StkShakers* unit);
};

//////////////////////////////////////////////////////////////////

void StkShakers_Ctor(StkShakers* unit)
{
// p0=freq, p1=shaker number, p2=energy, p3=system decay, p4=number of objects, p5 = resonance freq
	unit->shakers = new Shakers();
	//STKAlloc0(unit->mWorld,  unit->shakers, Shakers);
 
/******
    Control Change Numbers: 
       - Shake Energy = 2
       - System Decay = 4
       - Number Of Objects = 11
       - Resonance Frequency = 1
       - Instrument Selection = 1071
        - Maraca = 0
        - Cabasa = 1
        - Sekere = 2
        - Guiro = 3
        - Water Drops = 4
        - Bamboo Chimes = 5
        - Tambourine = 6
        - Sleigh Bells = 7
        - Sticks = 8
        - Crunch = 9
        - Wrench = 10
        - Sand Paper = 11
        - Coke Can = 12
        - Next Mug = 13
        - Penny + Mug = 14
        - Nickle + Mug = 15
        - Dime + Mug = 16
        - Quarter + Mug = 17
        - Franc + Mug = 18
        - Peso + Mug = 19
        - Big Rocks = 20
        - Little Rocks = 21
        - Tuned Bamboo Chimes = 22
*****/

 	unit->shakers->noteOn(220 ,1);
	unit->shakers->controlChange((int)1071, unit->shakernumber = IN0(0));
	unit->shakers->controlChange((int)2, unit->energy = IN0(1));
	unit->shakers->controlChange((int)4, unit->systemdecay = IN0(2));
	unit->shakers->controlChange((int)11, unit->numobjects = IN0(3));
	unit->shakers->controlChange((int)1, unit->resfreq = IN0(4));
	unit->trigger = 1;
 	SETCALC(StkShakers_next);
	StkShakers_next(unit, 1);
}

void StkShakers_next(StkShakers *unit, int inNumSamples)
{
	float *out OUT(0);
	
	
 	if(IN0(5) > 0) { 
		if(unit->trigger < 0) {  
			unit->shakers->noteOff( 0);
			unit->shakers->noteOn(IN0(0) ,1);
			
		};
	};
	unit->trigger = IN0(5);
	if(unit->shakernumber != IN0(0)) unit->shakers->controlChange((int)1071, unit->shakernumber = IN0(0));
	if(unit->energy != IN0(1)) unit->shakers->controlChange((int)2, unit->energy = IN0(1));
	if(unit->systemdecay != IN0(2)) unit->shakers->controlChange((int)4, unit->systemdecay = IN0(2));
	if(unit->numobjects != IN0(3)) unit->shakers->controlChange((int)11, unit->numobjects = IN0(3));
	if(unit->resfreq != IN0(4)) unit->shakers->controlChange((int)1, unit->resfreq = IN0(4));

 		
 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->shakers->tick();
        }
 }

void StkShakers_Dtor(StkShakers* unit)
{
	delete unit->shakers;
	unit->shakers->~Shakers();
   // RTFree(unit->mWorld, unit->shakers);

}

void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkShakers); 
}
 