#include "SC_PlugIn.h"
#include "STKAlloc.h"
#include "Sitar.h"
 
static InterfaceTable *ft;
   struct StkSitar : public Unit
{
	Sitar *sitar;
	float trig;
  };
  
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkSitar_next(StkSitar *unit, int inNumSamples);
        void StkSitar_Ctor(StkSitar* unit);
        void StkSitar_Dtor(StkSitar* unit);
};

//////////////////////////////////////////////////////////////////

void StkSitar_Ctor(StkSitar* unit)
{
 	STKAlloc(unit->mWorld, unit->sitar, Sitar, 40);
	unit->sitar->clear();
	unit->sitar->noteOn(IN0(0) ,1);
	SETCALC(StkSitar_next);
	unit->trig = 1;
	StkSitar_next(unit, 1);

}

void StkSitar_next(StkSitar *unit, int inNumSamples)
{
	float *out OUT(0);
 
 	if(IN0(1) > 0) { 
		if(unit->trig < 0) { 
				unit->sitar->noteOff( 0);
			    unit->sitar->noteOn(IN0(0) ,1);
				};
			};
	unit->trig = IN0(1);

 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->sitar->tick();
	}

}

void StkSitar_Dtor(StkSitar* unit)
{
	//delete unit->sitar;
	unit->sitar->~Sitar();
    RTFree(unit->mWorld, unit->sitar);

}
 
void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkSitar);
}
