#include "SC_PlugIn.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.tbl"
#include "STKAlloc.h"
#include "StifKarp.h"
 
static InterfaceTable *ft;
/*
    Control Change Numbers:
       - Pickup Position = 4
       - String Sustain = 11
       - String Stretch = 1
*/
  struct StkStifKarp : public Unit
{
	StifKarp *stifkarp;
	float freq;
	float pickuppos;
	float stringsustain;
	float stringstretch;
 };
 
extern "C"
{
        void load(InterfaceTable *inTable);
        void StkStifKarp_next(StkStifKarp *unit, int inNumSamples);
        void StkStifKarp_Ctor(StkStifKarp* unit);
        void StkStifKarp_Dtor(StkStifKarp* unit);
};

//////////////////////////////////////////////////////////////////

void StkStifKarp_Ctor(StkStifKarp* unit)
{
 	STKAlloc(unit->mWorld, unit->stifkarp, StifKarp, 40);

	unit->freq = unit->pickuppos = unit->stringsustain = unit->stringstretch = 0;
	unit->stifkarp->noteOn(IN0(0) ,IN0(1));
	SETCALC(StkStifKarp_next);
	StkStifKarp_next(unit, 1);
 
}

void StkStifKarp_next(StkStifKarp *unit, int inNumSamples)
{
	float *out OUT(0);
	float in00=IN0(0);
	float in01=IN0(2);
	float in02=IN0(3);
	float in03=IN0(4);

 
	if(in00 != unit->freq) {
		unit->stifkarp->setFrequency(in00);  
		unit->freq = in00;};
	
	if(in01 != unit->pickuppos) {
		unit->stifkarp->controlChange(4, in01);
		unit->pickuppos = in01; };
 	
	if(in02 != unit->stringsustain) {
		unit->stifkarp->controlChange(11, in02);
		unit->stringsustain = in02; };

	if(in03 != unit->stringstretch) {
		unit->stifkarp->controlChange(1, in03);
		unit->stringstretch = in03; };
 
 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->stifkarp->tick();
        }

}

void StkStifKarp_Dtor(StkStifKarp* unit)
{
	//delete unit->stifkarp;
	unit->stifkarp->~StifKarp();
    RTFree(unit->mWorld, unit->stifkarp);

}
 
void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkStifKarp);
}
