#include "SC_PlugIn.h"
#include "VoicForm.h"
#include "Phonemes.h"
#include "/Users/paul/stk-4.1.3/include/SKINI.msg"
#include "STKAlloc.h"

#include <math.h>

static InterfaceTable *ft;
 struct StkVoicForm : public Unit
{
	VoicForm *voiceForm;
	float freq;
	float vuvmix;
	float vowelphon;
	float vibfreq;
	float vibgain;
	float loudness;
	
	};

extern "C"
{
        void load(InterfaceTable *inTable);
        void StkVoicForm_next(StkVoicForm *unit, int inNumSamples);
        void StkVoicForm_Ctor(StkVoicForm* unit);
        void StkVoicForm_Dtor(StkVoicForm* unit);
};

//////////////////////////////////////////////////////////////////

void StkVoicForm_Ctor(StkVoicForm* unit)
{	
	//unit->voiceForm = new VoicForm();
	STKAlloc0(unit->mWorld,  unit->voiceForm, VoicForm);
	//unit->voiceForm = (VoicForm *)RTAlloc(unit->mWorld, sizeof(unit->voiceForm));

/*********************************
p0=freq,p1=vuvmix,p2=vowelphonsel,p3=vibfreq, p4=vibgain, p5=loudness
    Control Change Numbers: 
       - Voiced/Unvoiced Mix = 2
       - Vowel/Phoneme Selection = 4
       - Vibrato Frequency = 11
       - Vibrato Gain = 1
       - Loudness (Spectral Tilt) = 128
***********************************/
	unit->freq=IN0(0);
	unit->vuvmix=unit->vowelphon=unit->vibfreq=unit->vibgain=unit->loudness=0;
	unit->voiceForm->controlChange(2, IN0(1)); 	
	unit->voiceForm->controlChange(4, IN0(2));
	unit->voiceForm->controlChange(11, IN0(3));		
	unit->voiceForm->controlChange(1, IN0(4));		
	unit->voiceForm->controlChange(128, IN0(5));

 	unit->voiceForm->noteOn(IN0(0) ,1); 
  	SETCALC(StkVoicForm_next);
	StkVoicForm_next(unit, 1);
}
  
void StkVoicForm_next(StkVoicForm *unit, int inNumSamples)
{
	float *out=OUT(0);
	float in00=IN0(0);
	float in01=IN0(1);
	float in02=IN0(2);
	float in03=IN0(3);
	float in04=IN0(4);
	float in05=IN0(5);
 
 
	if(in00 != unit->freq) {
		unit->voiceForm->setFrequency(in00);  
		unit->freq = in00;};
	
	if(in01 != unit->vuvmix) {
		unit->voiceForm->controlChange(2, in01);
		unit->vuvmix = in01; };
 	
	if(in02 != unit->vowelphon) {
		unit->voiceForm->controlChange(4, in02);
		unit->vowelphon = in02; };

	if(in03 != unit->vibfreq) {
		unit->voiceForm->controlChange(11, in03);
		unit->vibfreq = in03; };
		
	if(in04 != unit->vibgain) {
		unit->voiceForm->controlChange(1, in04);
		unit->vibgain = in04; };
		
	if(in04 != unit->loudness) {
		unit->voiceForm->controlChange(128, in05);
		unit->vibgain = in05; };
 	 		
 	for (int i=0; i < inNumSamples; ++i)
	{
		out[i] = unit->voiceForm->tick();
        }
 }

void StkVoicForm_Dtor(StkVoicForm* unit)
{
	//unit->voiceForm->clear();
	//delete unit->voiceForm;
	unit->voiceForm->~VoicForm();
    RTFree(unit->mWorld, unit->voiceForm);
 
}

void load(InterfaceTable *inTable)
{
        ft = inTable;
        DefineDtorUnit(StkVoicForm); 
}
 