/* dictionary that keeps objects with the same key in a list and returns randomly one of them */

FuzzyDictionary : IdentityDictionary {

	put { arg key, item;
		var list;
		list = super.at(key);
		if(list.isNil, { 
			list = List.new;
			super.put(key, list)
		});
		list.add(item)
	}
	
	at { arg key;
		var list;
		list = super.at(key);
		^if(list.notNil, { list.choose },{ nil })
	}
	
	removeAt { arg key, item;
		var list;
		list = super.at(key);
		^if(list.notNil, {
			list.remove(item)
		}, nil)
		
	}

	choose {
		var list;
		list = super.choose;
		^if(list.notNil, { list.choose }, nil);
	}
	
	doAt { arg key, function;
		super.at(key).do(function);
	}
	
	keyAt { arg key;
		^super.at(key)
	}
	
}